<?php

if (!empty($setmodules))
{
	if (IS_SUPER_ADMIN) $module['MODS']['PARS_CONFIG'] = basename(__FILE__);
	return;
}

require('./pagestart.php');
require(INC_DIR .'functions_selects.php');

$return_links = array(
	'index' => '<br /><br />'. sprintf($lang['CLICK_RETURN_ADMIN_INDEX'], '<a href="index.php?pane=right">', '</a>'),
	'pars_cfg' => '<br /><br />'. sprintf($lang['CLICK_RETURN_PARS_CFG'], '<a href="admin_pars_cfg.php">', '</a>')
);

$sql = "SELECT * FROM " . BB_CONFIG;
if (!$result = DB()->sql_query($sql))
{
	bb_die('Could not query config information in admin_board');
}
else
{
	while ($row = DB()->sql_fetchrow($result))
	{
		$config_name = $row['config_name'];
		$config_value = $row['config_value'];
		$default_config[$config_name] = $config_value;

		$new[$config_name] = isset($_POST[$config_name]) ? $_POST[$config_name] : $default_config[$config_name];

		if (isset($_POST['submit']) && $row['config_value'] != $new[$config_name])
		{
			if ($config_name == 'seed_bonus_points' || $config_name == 'seed_bonus_release' || $config_name == 'bonus_upload' || $config_name == 'bonus_upload_price') $new[$config_name] = serialize(str_replace(',', '.', $new[$config_name]));
			bb_update_config(array($config_name => $new[$config_name]));
		}
	}

	if (isset($_POST['submit']))
	{
		bb_die($lang['CONFIG_UPDATED'] . $return_links['pars_cfg'] . $return_links['index']);
	}
}

$template->assign_vars(array(
	'S_CONFIG_ACTION'         	=> 'admin_pars_cfg.php',
	'DISABLE_PARSMOD'           	=> ($new['parsmod_disable']) ? true : false,
	'PARSMOD_RUTRACKER_LOGIN'       => $new['parsmod_rutracker_login'],
	'PARSMOD_RUTRACKER_PASSWORD'    => $new['parsmod_rutracker_password'],
));


print_page('admin_pars_cfg.tpl', 'admin');